/**
 * 
 */
package nist.pdpplugin.crypto;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.Collections;
import java.util.Enumeration;

import javax.net.ssl.X509TrustManager;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

/**
 * @author SJHA
 *
 */
public class AbacX509TrustManager implements X509TrustManager {

	private KeyStore keyStore;
	private static final String KEYSTORE_TYPE = "JKS";
	private static final String SECURE_ALGORITHM = "SunX509";
	static Logger log = LogManager.getLogger(AbacX509TrustManager .class);
	/**
	 * @throws IOException 
	 * @throws FileNotFoundException 
	 * @throws CertificateException 
	 * @throws NoSuchAlgorithmException 
	 * @throws KeyStoreException 
	 * 
	 */
	public AbacX509TrustManager(String keyStoreFilename,
            String keyStorePassword, String keyPassword) throws NoSuchAlgorithmException, CertificateException, FileNotFoundException, IOException, KeyStoreException {
		this.keyStore = KeyStore.getInstance(KEYSTORE_TYPE);
        

        File file=new File(keyStoreFilename);
        log.debug(keyStoreFilename+"existance status="+file.exists());
		this.keyStore.load(new FileInputStream(file),keyStorePassword.toCharArray() );
	}

	/* (non-Javadoc)
	 * @see javax.net.ssl.X509TrustManager#checkClientTrusted(java.security.cert.X509Certificate[], java.lang.String)
	 */
	@Override
	public void checkClientTrusted(X509Certificate[] arg0, String arg1)
			throws CertificateException {
		System.out.println("AbacX509TrustManager::checkClientTrusted");
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.net.ssl.X509TrustManager#checkServerTrusted(java.security.cert.X509Certificate[], java.lang.String)
	 */
	@Override
	public void checkServerTrusted(X509Certificate[] arg0, String arg1)
			throws CertificateException {
		System.out.println("AbacX509TrustManager::checkServerTrusted");
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.net.ssl.X509TrustManager#getAcceptedIssuers()
	 */
	@Override
	public X509Certificate[] getAcceptedIssuers() {
		 Enumeration<String> aliases=null;
		 Certificate cert=null;
		try {
			aliases = this.keyStore.aliases();
		} catch (KeyStoreException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		 X509Certificate[] x509Certs=new  X509Certificate[Collections.list(aliases).size()];
         int i=0;
         while (aliases.hasMoreElements()) {

             String alias = (String)aliases.nextElement();
             log.debug("AbacX509TrustManager:init:Inside while loop with alias="+alias);
            
			try {
				cert = this.keyStore.getCertificate(alias);
			} catch (KeyStoreException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
             x509Certs[i]=(X509Certificate) cert;
             i++;
         }
         System.out.println("Returning X509 cers of length="+x509Certs.length);
		 return (x509Certs);
	}

}
