package nist.pdpplugin.saml;

import org.opensaml.Configuration;
import org.opensaml.DefaultBootstrap;
import org.opensaml.xml.ConfigurationException;
import org.opensaml.xml.XMLObjectBuilderFactory;
import org.opensaml.xml.io.MarshallerFactory;
import org.opensaml.xml.io.UnmarshallerFactory;

public class SAMLInitializer {


	/**
	 * @return the initialized
	 */
	protected static boolean isInitialized() {
		return initialized;
	}
	/**
	 * @param initialized the initialized to set
	 */
	protected static void setInitialized(boolean initialized) {
		SAMLInitializer.initialized = initialized;
	}
	/**
	 * @return the builderFactory
	 */
	protected XMLObjectBuilderFactory getBuilderFactory() {
		return builderFactory;
	}
	/**
	 * @param builderFactory the builderFactory to set
	 */
	protected void setBuilderFactory(XMLObjectBuilderFactory builderFactory) {
		this.builderFactory = builderFactory;
	}
	/**
	 * @return the marshallerFactory
	 */
	protected MarshallerFactory getMarshallerFactory() {
		return marshallerFactory;
	}
	/**
	 * @param marshallerFactory the marshallerFactory to set
	 */
	protected void setMarshallerFactory(MarshallerFactory marshallerFactory) {
		this.marshallerFactory = marshallerFactory;
	}
	/**
	 * @return the unmarshallerFactory
	 */
	protected UnmarshallerFactory getUnmarshallerFactory() {
		return unmarshallerFactory;
	}
	/**
	 * @param unmarshallerFactory the unmarshallerFactory to set
	 */
	protected void setUnmarshallerFactory(UnmarshallerFactory unmarshallerFactory) {
		this.unmarshallerFactory = unmarshallerFactory;
	}
	/**
	 * @return the instance
	 */
	protected static SAMLInitializer getInstance() {
		return instance;
	}
	private static final SAMLInitializer instance = new SAMLInitializer();
	
	private static boolean initialized=false;
	protected static XMLObjectBuilderFactory builderFactory;
	/** Factory for XMLObject marshallers. */
    protected static MarshallerFactory marshallerFactory;

    /** Factory for XMLObject unmarshallers. */
    protected static UnmarshallerFactory unmarshallerFactory;
	protected SAMLInitializer()  {
    if(this.initialized==false){
		try {
			DefaultBootstrap.bootstrap();
		} catch (ConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		builderFactory = Configuration.getBuilderFactory();
        marshallerFactory = Configuration.getMarshallerFactory();
        unmarshallerFactory = Configuration.getUnmarshallerFactory();
        initialized=true;
	}
	}
}
