package nist.pdpplugin.servlet;

import java.io.IOException;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.SignatureException;
import java.security.UnrecoverableKeyException;
import java.security.cert.CertificateException;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nist.pdpplugin.transport.SoapHTTPTransmitter;

import org.opensaml.saml2.metadata.provider.MetadataProviderException;
import org.opensaml.xml.ConfigurationException;
import org.opensaml.xml.io.MarshallingException;
import org.opensaml.xml.security.SecurityException;
//import org.opensaml.xml.signature.SignatureException;
/**
 * Servlet implementation class SAMLProxy
 */
@WebServlet("/SAMLProxy")
public class SAMLProxy extends HttpServlet {
	private static final long serialVersionUID = 1L;
	private SoapHTTPTransmitter soapTransmitter;
    /**
     * @see HttpServlet#HttpServlet()
     */
    public SAMLProxy() {
        super();
        // TODO Auto-generated constructor stub
    }
    @Override
    public void init(ServletConfig config)
            throws ServletException{
    	try {
			soapTransmitter = new SoapHTTPTransmitter();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	@Override
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		throw new ServletException();
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	@Override
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html");
	   

	    String requester= request.getParameter("Requester");
	    String subjectId=request.getParameter("SubjectId");
	    String attributeName=request.getParameter("AttributeName");
	   
	    Map<String,List<String>> attributes;
       
			try {
				attributes = soapTransmitter.transmit(requester, subjectId, attributeName);

				ObjectOutput out = new ObjectOutputStream(
						response.getOutputStream());
				out.writeObject(attributes);
				out.close();
			
		} catch (UnrecoverableKeyException | KeyStoreException
				| NoSuchAlgorithmException | CertificateException
				| ConfigurationException | MetadataProviderException
				 | MarshallingException | org.opensaml.xml.security.SecurityException|org.opensaml.xml.signature.SignatureException e) {
			// TODO Auto-generated catch block
			throw new ServletException(e.getMessage());
		} 
	  
	   
	  }
	}


